
package org.mindswap.pellet;

import org.mindswap.pellet.exceptions.*;

import java.util.*;


public class IntMap{
	
	List non_negative;
	List negative;
	
	private int min=0;
	private int max=0;

	public IntMap(){
		negative = new ArrayList();
		non_negative = new ArrayList();
		negative.add(0,null);
	}

	//This method add v in position k
	public void add(int k, Object v){
        if(max<k){
            max = k;
        }
		if(k>=0){
			non_negative.add(k,v);
		}
		else{
            int k2 = -k;   //in ArrayList enumeration starts from 0, we don't need "0"
            if(min>k){
                min = k2;
            }
			negative.add(k2,v);
		}
	}

	//Same as add(int k, Object v)
	public void put(int k, Object v){
		add(k,v);
	}
	//match containing value v
	public boolean containsValue(Object v){
		int k = non_negative.indexOf(v);
		if(k ==-1){
			k = negative.indexOf(v);
			if(k == -1) return false;
		}
		return true;		
	}
	//Return index of Object v
	public int indexOf(Object v){
		int k = non_negative.indexOf(v);
		if(k ==-1){
			k = negative.indexOf(v);
			if(k == -1) throw new IntMapException("Object" + v + "is not found");
			k=-k;
		}
		return k;
	}
	
	public Object get(int k){
        if(k>=0){
			return non_negative.get(k);
		}
		else{
              return negative.get(-k);
		}
	}

	public int size(){
		return non_negative.size() + negative.size()/*-1*/;
	}
	
	public int getMin(){
		return min;
	}
	
	public int getMax(){
		return max;
	}

    public void replace (int k, Object v) {
        if (k>=0){
            non_negative.remove(k);
            non_negative.add(k,v);
        }
        else {
            negative.remove(-k);
            negative.add(-k,v);
        }
    }
    public void print (){
        int i;
        for (i=0;i<=this.getMax();i++) {System.out.println("Non-negative "+ i + "="+ this.get(i) );}
        for (i=-1;i>=-this.getMin();i--) {System.out.println("negative "+ i + "="+ this.get(i) ); }
    }
    public static void main (String[] args){
        IntMap ts = new IntMap();
        ts.add(0,"zero");
        ts.add(1,"one");
        ts.add(-1, "minus one");
        ts.print();
        ts.replace(1,"new one");
        ts.print();
    }

}
