package org.mindswap.pelletmet;

/**
 * User: NataKeberle
 * Date: 23/07/2009
 * Time: 20:32:31
 */

import aterm.*;
import junit.framework.*;
import org.mindswap.pellet.*;
import org.mindswap.pellet.utils.*;


public class MiscMeTTests extends PelletMeTTestCase {
    public static String base = PelletMeTTestSuite.base + "tsat/";

    public static TestSuite suite() {
        TestSuite s = new TestSuite( "MiscMeTTests" );
        s.addTestSuite( MiscMeTTests.class );

        return s;
    }


    public void testOWLMET1() {
        KnowledgeBase kb = new KnowledgeBase();
        IntMap ts = new IntMap();
        ATermAppl now = ATermUtils.makeTermAppl("now");
        ts.add(0,now);
        kb.setTS(ts);

        String[] timers = null;
        Boolean[] testres = null;

        int i;
        timers = new String[30]; // TODO depends on number of tests in  testNN-SAT.txt
        testres = new Boolean[30];
        for (i=0;i<30;i++) {
            timers[i] = "n/a";
            testres[i] = false;
        }

        org.mindswap.pellet.utils.Timer timer = new org.mindswap.pellet.utils.Timer("SAT-checking");

        i = 1;
        timer.start();
        kb.clear();
        kb.setTS(ts);
        kb.addSubClass(fut(term("A"),5),term("B"));
        testres[i-1] = kb.isConsistent() ;

        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();

        i = 2;
        timer.start();
        kb.clear();
        kb.setTS(ts);
        kb.addSubClass(fut(past(fut(term("A"),5),5),1),term("B"));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();


        i = 3;
        timer.start();
        kb.clear();
        kb.setTS(ts);
        kb.addSubClass(fut(fut(term("A"),1),2),fut(fut(term("B"),1),2));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();


        i = 4;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addSubClass(fut(not(fut(term("A"),1)),2),fut(not(fut(term("B"),1)),2));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();


        i = 5;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addSubClass(fut(fut(fut(fut(fut(fut(fut(fut(fut(fut(term("A"),1),2),3),4),5),6),7),8),9),10),fut(fut(fut(fut(fut(fut(fut(fut(fut(fut(term("B"),1),2),3),4),5),6),7),8),9),10));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();


        i = 6;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addSubClass(past(past(past(past(past(past(past(past(past(past(term("A"),1),2),3),4),5),6),7),8),9),10),past(past(past(past(past(past(past(past(past(past(term("B"),1),2),3),4),5),6),7),8),9),10));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();


        i = 7;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addSubClass(past(fut(past(fut(past(fut(past(fut(past(fut(term("A"),1),2),3),4),5),6),7),8),9),10),past(fut(past(fut(past(fut(past(fut(past(fut(term("B"),1),2),3),4),5),6),7),8),9),10));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();


        i = 8;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addSubClass(fut(fut(past(past(past(fut(fut(past(past(fut(term("A"),1),2),3),4),5),6),7),8),9),10),fut(fut(past(past(past(fut(fut(past(past(fut(term("B"),1),2),3),4),5),6),7),8),9),10));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();


        i = 9;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addSubClass(fut(fut(fut(fut(fut(fut(fut(fut(fut(fut(term("A"),1),2),3),4),5),6),7),8),9),10),past(past(past(past(past(past(past(past(past(past(term("B"),1),2),3),4),5),6),7),8),9),10));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();


        i = 10;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addSubClass(fut(not(fut(not(fut(not(fut(not(fut(not(fut(not(term("A")),1)),2)),3)),4)),5)),6),fut(not(fut(not(fut(not(fut(not(fut(not(fut(not(term("B")),1)),2)),3)),4)),5)),6));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();


        i = 11;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addSubClass(fut(not(not(not(fut(not(not(not(fut(not(not(not(term("A")))),1)))),2)))),3),past(not(not(not(past(not(not(not(past(not(not(not(term("B")))),1)))),2)))),3));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();


        i = 12;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addSubClass(fut(not(past(not(fut(not(past(not(fut(not(past(not(term("A")),1)),2)),3)),4)),5)),6),fut(not(past(not(fut(not(past(not(fut(not(past(not(term("B")),1)),2)),3)),4)),5)),6));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();


        i = 13;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addSubClass(past(not(not(not(fut(not(not(not(fut(not(not(not(term("A")))),1)))),2)))),3),past(not(not(not(past(not(not(not(past(not(not(not(term("B")))),1)))),2)))),3));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();


        i = 14;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addSubClass(past(not(past(not(fut(not(past(not(fut(not(past(not(term("A")),1)),2)),3)),4)),5)),6),fut(not(past(not(fut(not(past(not(fut(not(past(not(term("B")),1)),2)),3)),4)),5)),6));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();


        i = 15;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addSubClass(fut(fut(fut(fut(fut(fut(fut(fut(fut(past(term("A"),1),2),3),4),5),6),7),8),9),10),fut(fut(fut(fut(fut(fut(fut(fut(past(fut(term("B"),1),2),3),4),5),6),7),8),9),10));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();


// -----------equivalences---------------
        i = 16;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(fut(term("A"),5),term("B"));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();


        i = 17;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(fut(past(fut(term("A"),5),5),1),term("B"));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();


        i = 18;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(fut(fut(term("A"),1),2),fut(fut(term("B"),1),2));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();


        i = 19;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(fut(not(fut(term("A"),1)),2),fut(not(fut(term("B"),1)),2));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();


        i = 20;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(fut(fut(fut(fut(fut(fut(fut(fut(fut(fut(term("A"),1),2),3),4),5),6),7),8),9),10),fut(fut(fut(fut(fut(fut(fut(fut(fut(fut(term("B"),1),2),3),4),5),6),7),8),9),10));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();


        i = 21;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(past(past(past(past(past(past(past(past(past(past(term("A"),1),2),3),4),5),6),7),8),9),10),past(past(past(past(past(past(past(past(past(past(term("B"),1),2),3),4),5),6),7),8),9),10));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();


        i = 22;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(past(fut(past(fut(past(fut(past(fut(past(fut(term("A"),1),2),3),4),5),6),7),8),9),10),past(fut(past(fut(past(fut(past(fut(past(fut(term("B"),1),2),3),4),5),6),7),8),9),10));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();


        i = 23;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(fut(fut(past(past(past(fut(fut(past(past(fut(term("A"),1),2),3),4),5),6),7),8),9),10),fut(fut(past(past(past(fut(fut(past(past(fut(term("B"),1),2),3),4),5),6),7),8),9),10));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();


        i = 24;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(fut(fut(fut(fut(fut(fut(fut(fut(fut(fut(term("A"),1),2),3),4),5),6),7),8),9),10),past(past(past(past(past(past(past(past(past(past(term("B"),1),2),3),4),5),6),7),8),9),10));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();


        i = 25;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(fut(not(fut(not(fut(not(fut(not(fut(not(fut(not(term("A")),1)),2)),3)),4)),5)),6),fut(not(fut(not(fut(not(fut(not(fut(not(fut(not(term("B")),1)),2)),3)),4)),5)),6));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();


        i = 26;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(fut(not(not(not(fut(not(not(not(fut(not(not(not(term("A")))),1)))),2)))),3),past(not(not(not(past(not(not(not(past(not(not(not(term("B")))),1)))),2)))),3));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();


        i = 27;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(fut(not(past(not(fut(not(past(not(fut(not(past(not(term("A")),1)),2)),3)),4)),5)),6),fut(not(past(not(fut(not(past(not(fut(not(past(not(term("B")),1)),2)),3)),4)),5)),6));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();


        i = 28;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(past(not(not(not(fut(not(not(not(fut(not(not(not(term("A")))),1)))),2)))),3),past(not(not(not(past(not(not(not(past(not(not(not(term("B")))),1)))),2)))),3));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();


        i = 29;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(past(not(past(not(fut(not(past(not(fut(not(past(not(term("A")),1)),2)),3)),4)),5)),6),fut(not(past(not(fut(not(past(not(fut(not(past(not(term("B")),1)),2)),3)),4)),5)),6));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();


        i = 30;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(fut(fut(fut(fut(fut(fut(fut(fut(fut(past(term("A"),1),2),3),4),5),6),7),8),9),10),fut(fut(fut(fut(fut(fut(fut(fut(past(fut(term("B"),1),2),3),4),5),6),7),8),9),10));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test1 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test1 " + " : " + i + " : "+  timer.getLast();


//--------------Resulting timers-to file-----------------
        String s1 = base + "/test1-SAT-timer.txt";
        String s2 = base + "/test1-SAT-res.txt";


        java.io.Writer writer = null;
        try
        {
        java.io.File file2 = new java.io.File(s1);
        writer = new java.io.BufferedWriter(new java.io.FileWriter(file2));
            for (i = 0;i<timers.length;i++) {
                writer.write(timers[i]);
                writer.write(System.getProperty("line.separator"));
            }
        } catch (java.io.FileNotFoundException e)
        { e.printStackTrace();} catch (java.io.IOException e) {e.printStackTrace();
        } finally
        {  try
             { if (writer != null)
             { writer.close(); }
        } catch (java.io.IOException e)
        { e.printStackTrace(); }
        }
//--------------Resulting normalized tboxes-to file-----------------

        try
        {
        java.io.File file2 = new java.io.File(s2);
        writer = new java.io.BufferedWriter(new java.io.FileWriter(file2));
            for (i = 0;i<testres.length;i++) {
                if (testres[i]==null)
                writer.write("empty");
                else
                writer.write(testres[i].toString());
               // writer.write(testres[i]);
                writer.write(System.getProperty("line.separator"));
            }
        } catch (java.io.FileNotFoundException e)
        { e.printStackTrace();} catch (java.io.IOException e) {e.printStackTrace();
        } finally
        {  try
             { if (writer != null)
             { writer.close(); }
        } catch (java.io.IOException e)
        { e.printStackTrace(); }
        }


        for (i=0;i<30;i++)
            System.out.println("test timer"+ " : " + i + " : " + timers[i]);
        for (i=0;i<30;i++)
            System.out.println("test-SAT "+ " : " + i + " : " + testres[i]);
    }

//================================OWLT-2222222222222222222222222===============================
    public void testOWLMET2() {
        KnowledgeBase kb = new KnowledgeBase();
        IntMap ts = new IntMap();
        ATermAppl now = ATermUtils.makeTermAppl("now");
        ts.add(0,now);
        kb.setTS(ts);

        String[] timers = null;
        Boolean[] testres = null;
        int i;
        timers = new String[30];
        testres = new Boolean[30];
        for (i=0;i<30;i++) {
            timers[i] = "n/a";
            testres[i] = false;
        }

        org.mindswap.pellet.utils.Timer timer = new org.mindswap.pellet.utils.Timer("SAT-checking");
        i = 1;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(allfut(term("A")),term("B"));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


        i = 2;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(fut(allfut(term("A")),2),fut(allfut(term("B")),2));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


        i = 3;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(fut(allpast(fut(term("A"),5)),1),term("B"));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


        i = 4;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addSubClass(allfut(not(fut(term("A"),1))),allpast(not(fut(term("B"),1))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


        i = 5;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(allfut(allfut(allfut(allfut(allfut(allfut(allfut(allfut(allfut(fut(term("A"),1)))))))))),past(past(past(past(past(past(past(past(past(past(term("B"),1),2),3),4),5),6),7),8),9),10));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


        i = 6;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addSubClass(allfut(not(fut(term("A"),1))),allpast(not(fut(term("B"),1))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


        i = 7;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addSubClass(allpast(allfut(allpast(allfut(allpast(allfut(allpast(allfut(allpast(allfut(term("A"))))))))))),allpast(allfut(allpast(allfut(allpast(allfut(allpast(allfut(allpast(allfut(term("B"))))))))))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


        i = 8;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addSubClass(past(past(past(past(past(past(past(past(past(allpast(term("A")),2),3),4),5),6),7),8),9),10),past(past(past(past(past(past(past(past(past(allpast(term("B")),2),3),4),5),6),7),8),9),10));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


        i = 9;
        timer.start();
        kb.clear();
        kb.setTS(ts);

        kb.addSubClass(fut(fut(past(past(past(fut(fut(past(past(allfut(term("A")),2),3),4),5),6),7),8),9),10),fut(fut(past(past(past(fut(fut(past(past(allfut(term("B")),2),3),4),5),6),7),8),9),10));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


        i = 10;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(allfut(allfut(allfut(allfut(fut(fut(fut(fut(fut(fut(term("A"),1),2),3),4),5),6))))),allfut(fut(fut(fut(fut(fut(fut(fut(fut(fut(term("B"),1),2),3),4),5),6),7),8),9)));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


        i = 11;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(allfut(not(allfut(not(allfut(not(allfut(not(allfut(not(allfut(not(term("B"))))))))))))),allfut(not(allfut(not(allfut(not(allfut(not(allfut(not(allfut(not(term("A"))))))))))))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


        i = 12;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addSubClass(allfut(not(allfut(not(allfut(not(allfut(not(allfut(not(allfut(not(term("A"))))))))))))),allfut(not(allfut(not(allfut(not(allfut(not(allfut(not(allfut(not(term("A"))))))))))))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


        i = 13;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addSubClass(allfut(not(not(not(fut(not(not(not(fut(not(not(not(term("A")))),1)))),2))))),allpast(not(not(not(past(not(not(not(past(not(not(not(term("B")))),1)))),2))))));        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


        i = 14;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addSubClass(fut(somefut(fut(somefut(fut(somefut(term("A")),5)),4)),3),term("B"));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


        i = 15;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addSubClass(fut(not(allpast(not(term("A")))),2),fut(not(past(not(fut(not(allfut(not(term("B")))),1)),2)),3));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


// -----------equivalences---------------
        i = 16;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(allfut(term("A")),term("B"));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


        i = 17;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(fut(allfut(term("A")),2),fut(allfut(term("B")),2));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


        i = 18;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(fut(allpast(fut(term("A"),5)),1),term("B"));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


        i = 19;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(allfut(not(fut(term("A"),1))),allpast(not(fut(term("B"),1))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


        i = 20;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(allfut(allfut(allfut(allfut(allfut(allfut(allfut(allfut(allfut(fut(term("A"),1)))))))))),past(past(past(past(past(past(past(past(past(past(term("B"),1),2),3),4),5),6),7),8),9),10));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


        i = 21;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(allfut(not(fut(term("A"),1))),allpast(not(fut(term("B"),1))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


        i = 22;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(allpast(allfut(allpast(allfut(allpast(allfut(allpast(allfut(allpast(allfut(term("A"))))))))))),allpast(allfut(allpast(allfut(allpast(allfut(allpast(allfut(allpast(allfut(term("B"))))))))))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


        i = 23;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(past(past(past(past(past(past(past(past(past(allpast(term("A")),2),3),4),5),6),7),8),9),10),past(past(past(past(past(past(past(past(past(allpast(term("B")),2),3),4),5),6),7),8),9),10));        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


        i = 24;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(fut(fut(past(past(past(fut(fut(past(past(allfut(term("A")),2),3),4),5),6),7),8),9),10),fut(fut(past(past(past(fut(fut(past(past(allfut(term("B")),2),3),4),5),6),7),8),9),10));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


        i = 25;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(allfut(allfut(allfut(allfut(fut(fut(fut(fut(fut(fut(term("A"),1),2),3),4),5),6))))),allfut(fut(fut(fut(fut(fut(fut(fut(fut(fut(term("B"),1),2),3),4),5),6),7),8),9)));        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


        i = 26;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(allfut(not(allfut(not(allfut(not(allfut(not(allfut(not(allfut(not(term("B"))))))))))))),allfut(not(allfut(not(allfut(not(allfut(not(allfut(not(allfut(not(term("A"))))))))))))));        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


        i = 27;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(allfut(not(allfut(not(allfut(not(allfut(not(allfut(not(allfut(not(term("A"))))))))))))),allfut(not(allfut(not(allfut(not(allfut(not(allfut(not(allfut(not(term("A"))))))))))))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


        i = 28;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(allfut(not(not(not(fut(not(not(not(fut(not(not(not(term("A")))),1)))),2))))),allpast(not(not(not(past(not(not(not(past(not(not(not(term("B")))),1)))),2))))));        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


        i = 29;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(fut(somefut(fut(somefut(fut(somefut(term("A")),5)),4)),3),term("B"));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


        i = 30;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(fut(not(allpast(not(term("A")))),2),fut(not(past(not(fut(not(allfut(not(term("B")))),1)),2)),3));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test2 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test2 " + " : " + i + " : "+  timer.getLast();


//--------------Resulting timers-to file-----------------
        String s1 = base + "/test2-SAT-timer.txt";
        String s2 = base + "/test2-SAT-res.txt";


        java.io.Writer writer = null;
        try
        {
        java.io.File file2 = new java.io.File(s1);
        writer = new java.io.BufferedWriter(new java.io.FileWriter(file2));
            for (i = 0;i<timers.length;i++) {
                writer.write(timers[i]);
                writer.write(System.getProperty("line.separator"));
            }
        } catch (java.io.FileNotFoundException e)
        { e.printStackTrace();} catch (java.io.IOException e) {e.printStackTrace();
        } finally
        {  try
             { if (writer != null)
             { writer.close(); }
        } catch (java.io.IOException e)
        { e.printStackTrace(); }
        }
//--------------Resulting normalized tboxes-to file-----------------

        try
        {
        java.io.File file2 = new java.io.File(s2);
        writer = new java.io.BufferedWriter(new java.io.FileWriter(file2));
            for (i = 0;i<testres.length;i++) {
                if (testres[i]==null)
                writer.write("empty");
                else
                writer.write(testres[i].toString());
               // writer.write(testres[i]);
                writer.write(System.getProperty("line.separator"));
            }
        } catch (java.io.FileNotFoundException e)
        { e.printStackTrace();} catch (java.io.IOException e) {e.printStackTrace();
        } finally
        {  try
             { if (writer != null)
             { writer.close(); }
        } catch (java.io.IOException e)
        { e.printStackTrace(); }
        }


        for (i=0;i<30;i++)
            System.out.println("test timer"+ " : " + i + " : " + timers[i]);
        for (i=0;i<30;i++)
            System.out.println("test-SAT "+ " : " + i + " : " + testres[i]);
    }

//================================OWLT-3333333333333333333333333===============================
    public void testOWLMET3() {
        KnowledgeBase kb = new KnowledgeBase();
        IntMap ts = new IntMap();
        ATermAppl now = ATermUtils.makeTermAppl("now");
        ts.add(0,now);
        kb.setTS(ts);

        String[] timers = null;
        Boolean[] testres = null;
        int i;
        timers = new String[30];
        testres = new Boolean[30];
        for (i=0;i<30;i++) {
            timers[i] = "n/a";
            testres[i] = false;
        }

        org.mindswap.pellet.utils.Timer timer = new org.mindswap.pellet.utils.Timer("SAT-checking");
        i = 1;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(somefut(term("A")),term("B"));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


        i = 2;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(fut(somefut(term("A")),2),fut(somefut(term("B")),2));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


        i = 3;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(fut(somepast(fut(term("A"),5)),1),term("B"));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


        i = 4;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(somefut(not(fut(term("A"),1))),somepast(not(fut(term("B"),1))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


        i = 5;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(somefut(somefut(somefut(somefut(somefut(somefut(somefut(somefut(somefut(fut(term("A"),1)))))))))),past(past(past(past(past(past(past(past(past(past(term("B"),1),2),3),4),5),6),7),8),9),10));

        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


        i = 6;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(somefut(not(fut(term("A"),1))),somepast(not(fut(term("B"),1))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


        i = 7;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addSubClass(somepast(somefut(somepast(somefut(somepast(somefut(somepast(somefut(somepast(somefut(term("A"))))))))))),somepast(somefut(somepast(somefut(somepast(somefut(somepast(somefut(somepast(somefut(term("B"))))))))))));        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


        i = 8;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(past(past(past(past(past(past(past(past(past(somepast(term("A")),2),3),4),5),6),7),8),9),10),past(past(past(past(past(past(past(past(past(somepast(term("B")),2),3),4),5),6),7),8),9),10));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


        i = 9;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(fut(fut(past(past(past(fut(fut(past(past(somefut(term("A")),2),3),4),5),6),7),8),9),10),fut(fut(past(past(past(fut(fut(past(past(somefut(term("B")),2),3),4),5),6),7),8),9),10));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


        i = 10;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(somefut(somefut(somefut(somefut(fut(fut(fut(fut(fut(fut(term("A"),1),2),3),4),5),6))))),somefut(fut(fut(fut(fut(fut(fut(fut(fut(fut(term("B"),1),2),3),4),5),6),7),8),9)));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


        i = 11;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(term("B"))))))))))))),somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(term("A"))))))))))))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


        i = 12;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(term("A"))))))))))))),somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(term("A"))))))))))))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


        i = 13;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(somefut(not(not(not(fut(not(not(not(fut(not(not(not(term("A")))),1)))),2))))),somepast(not(not(not(past(not(not(not(past(not(not(not(term("B")))),1)))),2))))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


        i = 14;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(fut(somefut(fut(somefut(fut(somefut(term("A")),5)),4)),3),term("B"));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


        i = 15;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(fut(not(somepast(not(term("A")))),2),fut(not(past(not(fut(not(somefut(not(term("B")))),1)),2)),3));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


// -----------equivalences---------------
        i = 16;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(somefut(term("A")),term("B"));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


        i = 17;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(fut(somefut(term("A")),2),fut(somefut(term("B")),2));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


        i = 18;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(fut(somepast(fut(term("A"),5)),1),term("B"));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


        i = 19;
        timer.start();
        kb.clear();
        kb.setTS(ts);
        kb.addEquivalentClass(somefut(not(fut(term("A"),1))),somepast(not(fut(term("B"),1))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


        i = 20;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(somefut(somefut(somefut(somefut(somefut(somefut(somefut(somefut(somefut(fut(term("A"),1)))))))))),past(past(past(past(past(past(past(past(past(past(term("B"),1),2),3),4),5),6),7),8),9),10));

        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


        i = 21;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(somefut(not(fut(term("A"),1))),somepast(not(fut(term("B"),1))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


        i = 22;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(somepast(somefut(somepast(somefut(somepast(somefut(somepast(somefut(somepast(somefut(term("A"))))))))))),somepast(somefut(somepast(somefut(somepast(somefut(somepast(somefut(somepast(somefut(term("B"))))))))))));

        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


        i = 23;
        timer.start();
        kb.clear();
        kb.setTS(ts);

kb.addEquivalentClass(past(past(past(past(past(past(past(past(past(somepast(term("A")),2),3),4),5),6),7),8),9),10),past(past(past(past(past(past(past(past(past(somepast(term("B")),2),3),4),5),6),7),8),9),10));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


        i = 24;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(fut(fut(past(past(past(fut(fut(past(past(somefut(term("A")),2),3),4),5),6),7),8),9),10),fut(fut(past(past(past(fut(fut(past(past(somefut(term("B")),2),3),4),5),6),7),8),9),10));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


        i = 25;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(somefut(somefut(somefut(somefut(fut(fut(fut(fut(fut(fut(term("A"),1),2),3),4),5),6))))),somefut(fut(fut(fut(fut(fut(fut(fut(fut(fut(term("B"),1),2),3),4),5),6),7),8),9)));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


        i = 26;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(term("B"))))))))))))),somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(term("A"))))))))))))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


        i = 27;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(term("A"))))))))))))),somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(term("A"))))))))))))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


        i = 28;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(somefut(not(not(not(fut(not(not(not(fut(not(not(not(term("A")))),1)))),2))))),somepast(not(not(not(past(not(not(not(past(not(not(not(term("B")))),1)))),2))))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


        i = 29;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(fut(somefut(fut(somefut(fut(somefut(term("A")),5)),4)),3),term("B"));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


        i = 30;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(fut(not(somepast(not(term("A")))),2),fut(not(past(not(fut(not(somefut(not(term("B")))),1)),2)),3));

        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test3 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test3 " + " : " + i + " : "+  timer.getLast();


//--------------Resulting timers-to file-----------------
        String s1 = base + "/test3-SAT-timer.txt";
        String s2 = base + "/test3-SAT-res.txt";

        java.io.Writer writer = null;
        try
        {
        java.io.File file2 = new java.io.File(s1);
        writer = new java.io.BufferedWriter(new java.io.FileWriter(file2));
            for (i = 0;i<timers.length;i++) {
                writer.write(timers[i]);
                writer.write(System.getProperty("line.separator"));
            }
        } catch (java.io.FileNotFoundException e)
        { e.printStackTrace();} catch (java.io.IOException e) {e.printStackTrace();
        } finally
        {  try
             { if (writer != null)
             { writer.close(); }
        } catch (java.io.IOException e)
        { e.printStackTrace(); }
        }
//--------------Resulting normalized tboxes-to file-----------------

        try
        {
        java.io.File file2 = new java.io.File(s2);
        writer = new java.io.BufferedWriter(new java.io.FileWriter(file2));
            for (i = 0;i<testres.length;i++) {
                if (testres[i]==null)
                writer.write("empty");
                else
                writer.write(testres[i].toString());
               // writer.write(testres[i]);
                writer.write(System.getProperty("line.separator"));
            }
        } catch (java.io.FileNotFoundException e)
        { e.printStackTrace();} catch (java.io.IOException e) {e.printStackTrace();
        } finally
        {  try
             { if (writer != null)
             { writer.close(); }
        } catch (java.io.IOException e)
        { e.printStackTrace(); }
        }


        for (i=0;i<30;i++)
            System.out.println("test timer"+ " : " + i + " : " + timers[i]);
        for (i=0;i<30;i++)
            System.out.println("test-SAT "+ " : " + i + " : " + testres[i]);
    }

//================================OWLT-4444444444444444444444444===============================
    public void testOWLMET4() {
        KnowledgeBase kb = new KnowledgeBase();
        IntMap ts = new IntMap();
        ATermAppl now = ATermUtils.makeTermAppl("now");
        ts.add(0,now);
        kb.setTS(ts);

        String[] timers = null;
        Boolean[] testres = null;
        int i;
        timers = new String[30];
        testres = new Boolean[30];
        for (i=0;i<30;i++) {
            timers[i] = "n/a";
            testres[i] = false;
        }

        org.mindswap.pellet.utils.Timer timer = new org.mindswap.pellet.utils.Timer("SAT-checking");
      i = 1;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(somefut(term("A")),term("B"));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();


        i = 2;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(allfut(somefut(term("A"))),allfut(somefut(term("B"))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();



        i = 3;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(allfut(somepast(allfut(term("A")))),term("B"));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();


        i = 4;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(somefut(not(allfut(term("A")))),somepast(not(allfut(term("B")))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();


        i = 5;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(somefut(somefut(somefut(somefut(somefut(somefut(somefut(somefut(somefut(allfut(term("A"))))))))))),allpast(allpast(allpast(allpast(allpast(allpast(allpast(allpast(allpast(allpast(term("B"))))))))))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();


        i = 6;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(somefut(not(allfut(term("A")))),somepast(not(allfut(term("B")))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();


        i = 7;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(somepast(somefut(somepast(somefut(somepast(somefut(somepast(somefut(somepast(somefut(term("A"))))))))))),somepast(somefut(somepast(somefut(somepast(somefut(somepast(somefut(somepast(somefut(term("B"))))))))))));

        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();


        i = 8;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(allpast(allpast(allpast(allpast(allpast(allpast(allpast(allpast(allpast(somepast(term("A"))))))))))),allpast(allpast(allpast(allpast(allpast(allpast(allpast(allpast(allpast(somepast(term("B"))))))))))));

        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();


        i = 9;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(allfut(allfut(allpast(allpast(allpast(allfut(allfut(allpast(allpast(somefut(term("A"))))))))))),allfut(allfut(allpast(allpast(allpast(allfut(allfut(allpast(allpast(somefut(term("B"))))))))))));

        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();


        i = 10;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(somefut(somefut(somefut(somefut(allfut(allfut(allfut(allfut(allfut(allfut(term("A"))))))))))),somefut(allfut(allfut(allfut(allfut(allfut(allfut(allfut(allfut(allfut(term("B"))))))))))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();


        i = 11;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(term("B"))))))))))))),somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(term("A"))))))))))))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();


        i = 12;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(term("A"))))))))))))),somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(term("A"))))))))))))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();


        i = 13;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(somefut(not(not(not(allfut(not(not(not(allfut(not(not(not(term("A"))))))))))))),somepast(not(not(not(allpast(not(not(not(allpast(not(not(not(term("B"))))))))))))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();


        i = 14;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(allfut(somefut(allfut(somefut(allfut(somefut(term("A"))))))),term("B"));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();


        i = 15;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(allfut(not(somepast(not(term("A"))))),allfut(not(allpast(not(allfut(not(somefut(not(term("B"))))))))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();


// -----------equivalences---------------
        i = 16;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(somefut(term("A")),term("B"));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();


        i = 17;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(allfut(somefut(term("A"))),allfut(somefut(term("B"))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();


        i = 18;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(allfut(somepast(allfut(term("A")))),term("B"));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();


        i = 19;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(somefut(not(allfut(term("A")))),somepast(not(allfut(term("B")))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();


        i = 20;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(somefut(somefut(somefut(somefut(somefut(somefut(somefut(somefut(somefut(allfut(term("A"))))))))))),allpast(allpast(allpast(allpast(allpast(allpast(allpast(allpast(allpast(allpast(term("B"))))))))))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();


        i = 21;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(somefut(not(allfut(term("A")))),somepast(not(allfut(term("B")))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();


        i = 22;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(somepast(somefut(somepast(somefut(somepast(somefut(somepast(somefut(somepast(somefut(term("A"))))))))))),somepast(somefut(somepast(somefut(somepast(somefut(somepast(somefut(somepast(somefut(term("B"))))))))))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();


        i = 23;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(allpast(allpast(allpast(allpast(allpast(allpast(allpast(allpast(allpast(somepast(term("A"))))))))))),allpast(allpast(allpast(allpast(allpast(allpast(allpast(allpast(allpast(somepast(term("B"))))))))))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();


        i = 24;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(allfut(allfut(allpast(allpast(allpast(allfut(allfut(allpast(allpast(somefut(term("A"))))))))))),allfut(allfut(allpast(allpast(allpast(allfut(allfut(allpast(allpast(somefut(term("B"))))))))))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();


        i = 25;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(somefut(somefut(somefut(somefut(allfut(allfut(allfut(allfut(allfut(allfut(term("A"))))))))))),somefut(allfut(allfut(allfut(allfut(allfut(allfut(allfut(allfut(allfut(term("B"))))))))))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();


        i = 26;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(term("B"))))))))))))),somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(term("A"))))))))))))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();


        i = 27;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(term("A"))))))))))))),somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(somefut(not(term("A"))))))))))))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();


        i = 28;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(somefut(not(not(not(allfut(not(not(not(allfut(not(not(not(term("A"))))))))))))),somepast(not(not(not(allpast(not(not(not(allpast(not(not(not(term("B"))))))))))))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();


        i = 29;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(allfut(somefut(allfut(somefut(allfut(somefut(term("A"))))))),term("B"));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();


        i = 30;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(allfut(not(somepast(not(term("A"))))),allfut(not(allpast(not(allfut(not(somefut(not(term("B"))))))))));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test4 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test4 " + " : " + i + " : "+  timer.getLast();


//--------------Resulting timers-to file-----------------
        String s1 = base + "/test4-SAT-timer.txt";
        String s2 = base + "/test4-SAT-res.txt";

        java.io.Writer writer = null;
        try
        {
        java.io.File file2 = new java.io.File(s1);
        writer = new java.io.BufferedWriter(new java.io.FileWriter(file2));
            for (i = 0;i<timers.length;i++) {
                writer.write(timers[i]);
                writer.write(System.getProperty("line.separator"));
            }
        } catch (java.io.FileNotFoundException e)
        { e.printStackTrace();} catch (java.io.IOException e) {e.printStackTrace();
        } finally
        {  try
             { if (writer != null)
             { writer.close(); }
        } catch (java.io.IOException e)
        { e.printStackTrace(); }
        }
//--------------Resulting normalized tboxes-to file-----------------

        try
        {
        java.io.File file2 = new java.io.File(s2);
        writer = new java.io.BufferedWriter(new java.io.FileWriter(file2));
            for (i = 0;i<testres.length;i++) {
                if (testres[i]==null)
                writer.write("empty");
                else
                writer.write(testres[i].toString());
               // writer.write(testres[i]);
                writer.write(System.getProperty("line.separator"));
            }
        } catch (java.io.FileNotFoundException e)
        { e.printStackTrace();} catch (java.io.IOException e) {e.printStackTrace();
        } finally
        {  try
             { if (writer != null)
             { writer.close(); }
        } catch (java.io.IOException e)
        { e.printStackTrace(); }
        }


        for (i=0;i<30;i++)
            System.out.println("test timer"+ " : " + i + " : " + timers[i]);
        for (i=0;i<30;i++)
            System.out.println("test-SAT "+ " : " + i + " : " + testres[i]);
    }

//================================OWLT-5555555555555555555555555===============================
    public void testOWLMET5() {
        KnowledgeBase kb = new KnowledgeBase();
        IntMap ts = new IntMap();
        ATermAppl now = ATermUtils.makeTermAppl("now");
        ts.add(0,now);
        ts.add(1,ATermUtils.makeTermAppl("x1"));
        ts.add(2,ATermUtils.makeTermAppl("x2"));
        ts.add(3,ATermUtils.makeTermAppl("x3"));
        ts.add(4,ATermUtils.makeTermAppl("x4"));
        ts.add(5,ATermUtils.makeTermAppl("x5"));
        ts.add(6,ATermUtils.makeTermAppl("x6"));
        ts.add(7,ATermUtils.makeTermAppl("x7"));
        ts.add(8,ATermUtils.makeTermAppl("x8"));
        ts.add(9,ATermUtils.makeTermAppl("x9"));
        
        kb.setTS(ts);

        String[] timers = null;
        Boolean[] testres = null;
        int i;
        timers = new String[30]; // TODO depends on the number of tests in testNN-SAT.txt
        testres = new Boolean[30];
        for (i=0;i<30;i++) {
            timers[i] = "n/a";
            testres[i] = false;
        }

        org.mindswap.pellet.utils.Timer timer = new org.mindswap.pellet.utils.Timer("SAT-checking");
        i = 1;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(at(term("C"),term("x1")),fut(and(term("A"),term("B")),1));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


        i = 2;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(at(at(at(at(at(at(at(at(at(term("C"),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")),term("B"));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


        i = 3;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(at(term("C"),term("x1")),fut(past(fut(term("A"),5),5),1));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


        i = 4;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(at(term("D"),term("x2")),fut(fut(fut(fut(fut(fut(fut(fut(fut(fut(term("A"),1),2),3),4),5),6),7),8),9),10));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


        i = 5;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(at(term("C"),term("x1")),past(fut(past(fut(past(fut(past(fut(past(fut(term("A"),1),2),3),4),5),6),7),8),9),10));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


        i = 6;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(at(at(at(at(at(at(at(at(at(term("C"),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")),fut(not(fut(not(fut(not(fut(not(fut(not(fut(not(term("A")),1)),2)),3)),4)),5)),6));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


        i = 7;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(at(at(at(at(at(at(at(at(at(term("C"),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")),fut(fut(past(past(past(fut(fut(past(past(fut(term("A"),1),2),3),4),5),6),7),8),9),10));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


        i = 8;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(at(at(at(at(at(at(at(at(at(term("C"),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")),fut(not(not(not(fut(not(not(not(fut(not(not(not(term("A")))),1)))),2)))),3));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


        i = 9;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(at(at(at(at(at(at(at(at(at(term("C"),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")),fut(not(past(not(fut(not(past(not(fut(not(past(not(term("A")),1)),2)),3)),4)),5)),6));

        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


        i = 10;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(at(at(at(at(at(at(at(at(at(term("C"),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")),at(at(at(at(at(at(at(at(at(term("C"),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")));

        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


        i = 11;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(at(at(at(at(at(at(at(at(at(fut(term("C"),1),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")),at(at(at(at(at(at(at(at(at(fut(not(term("C")),1),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


        i = 12;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(at(at(at(at(at(at(at(at(at(past(fut(term("C"),1),1),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")),at(at(at(at(at(at(at(at(at(fut(not(past(term("D"),1)),1),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


        i = 13;
        timer.start();
        kb.clear();
        kb.setTS(ts);
        kb.addSubClass(at(at(at(at(at(at(at(at(at(past(past(term("C"),1),2),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")),at(at(at(at(at(at(at(at(at(fut(not(fut(term("C"),5)),1),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


        i = 14;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(at(at(at(at(at(at(at(at(at(past(term("C"),1),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")),at(at(at(at(at(at(at(at(at(not(fut(not(past(term("D"),1)),1)),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


        i = 15;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addSubClass(fut(term("A"),55),at(term("A"),term("x5")));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


// -----------equivalences---------------
        i = 16;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(at(term("C"),term("x1")),fut(term("A"),5));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


        i = 17;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(at(at(at(at(at(at(at(at(at(term("C"),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")),term("B"));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


        i = 18;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(at(term("C"),term("x1")),fut(past(fut(term("A"),5),5),1));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


        i = 19;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(at(term("D"),term("x2")),fut(fut(fut(fut(fut(fut(fut(fut(fut(fut(term("A"),1),2),3),4),5),6),7),8),9),10));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


        i = 20;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(at(term("C"),term("x1")),past(fut(past(fut(past(fut(past(fut(past(fut(term("A"),1),2),3),4),5),6),7),8),9),10));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


        i = 21;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(at(at(at(at(at(at(at(at(at(term("C"),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")),fut(not(fut(not(fut(not(fut(not(fut(not(fut(not(term("A")),1)),2)),3)),4)),5)),6));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


        i = 22;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(at(at(at(at(at(at(at(at(at(term("C"),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")),fut(fut(past(past(past(fut(fut(past(past(fut(term("A"),1),2),3),4),5),6),7),8),9),10));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


        i = 23;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(at(at(at(at(at(at(at(at(at(term("C"),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")),fut(not(not(not(fut(not(not(not(fut(not(not(not(term("A")))),1)))),2)))),3));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


        i = 24;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(at(at(at(at(at(at(at(at(at(term("C"),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")),fut(not(past(not(fut(not(past(not(fut(not(past(not(term("A")),1)),2)),3)),4)),5)),6));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


        i = 25;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(at(at(at(at(at(at(at(at(at(term("C"),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")),at(at(at(at(at(at(at(at(at(term("C"),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


        i = 26;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(at(at(at(at(at(at(at(at(at(fut(term("C"),1),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")),at(at(at(at(at(at(at(at(at(fut(not(term("C")),1),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


        i = 27;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(at(at(at(at(at(at(at(at(at(past(fut(term("C"),1),1),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")),at(at(at(at(at(at(at(at(at(fut(not(past(term("D"),1)),1),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


        i = 28;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(at(at(at(at(at(at(at(at(at(past(past(term("C"),1),2),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")),at(at(at(at(at(at(at(at(at(fut(not(fut(term("C"),5)),1),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


        i = 29;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(at(at(at(at(at(at(at(at(at(past(term("C"),1),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")),at(at(at(at(at(at(at(at(at(not(fut(not(past(term("D"),1)),1)),term("x1")),term("x2")),term("x3")),term("x4")),term("x5")),term("x6")),term("x7")),term("x8")),term("x9")));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


        i = 30;
        timer.start();
        kb.clear();
        kb.setTS(ts);
kb.addEquivalentClass(fut(fut(fut(fut(fut(fut(fut(fut(fut(fut(term("A"),1),2),3),4),5),6),7),8),9),10),fut(fut(fut(fut(fut(fut(fut(fut(fut(fut(at(term("A"),term("x5")),1),2),3),4),5),6),7),8),9),10));
        testres[i-1] = kb.isConsistent() ;
        timer.stop();
        System.out.println("test5 " + i + " : "+  " : "+  timer.getLast());
        timers[i-1] = "test5 " + " : " + i + " : "+  timer.getLast();


//--------------Resulting timers-to file-----------------
        String s1 = base + "/test5-SAT-timer.txt";
        String s2 = base + "/test5-SAT-res.txt";

        java.io.Writer writer = null;
        try
        {
        java.io.File file2 = new java.io.File(s1);
        writer = new java.io.BufferedWriter(new java.io.FileWriter(file2));
            for (i = 0;i<timers.length;i++) {
                writer.write(timers[i]);
                writer.write(System.getProperty("line.separator"));
            }
        } catch (java.io.FileNotFoundException e)
        { e.printStackTrace();} catch (java.io.IOException e) {e.printStackTrace();
        } finally
        {  try
             { if (writer != null)
             { writer.close(); }
        } catch (java.io.IOException e)
        { e.printStackTrace(); }
        }
//--------------Resulting normalized tboxes-to file-----------------

        try
        {
        java.io.File file2 = new java.io.File(s2);
        writer = new java.io.BufferedWriter(new java.io.FileWriter(file2));
            for (i = 0;i<testres.length;i++) {
                if (testres[i]==null)
                writer.write("empty");
                else
                writer.write(testres[i].toString());
               // writer.write(testres[i]);
                writer.write(System.getProperty("line.separator"));
            }
        } catch (java.io.FileNotFoundException e)
        { e.printStackTrace();} catch (java.io.IOException e) {e.printStackTrace();
        } finally
        {  try
             { if (writer != null)
             { writer.close(); }
        } catch (java.io.IOException e)
        { e.printStackTrace(); }
        }


        for (i=0;i<30;i++)
            System.out.println("test timer"+ " : " + i + " : " + timers[i]);
        for (i=0;i<30;i++)
            System.out.println("test-SAT "+ " : " + i + " : " + testres[i]);
    }

}
