package org.mindswap.pelletmet;

/**
 * User: NataKeberle
 * Date: 23/07/2009
 * Time: 20:39:31
 */

import aterm.*;
import junit.framework.*;
import org.mindswap.pellet.tbox.impl.*;
import org.mindswap.pellet.utils.*;

import java.util.*;


public class NormalizationMeTTests extends PelletMeTTestCase {
    public static String base = PelletMeTTestSuite.base + "tsat/";

    public static TestSuite suite() {
        TestSuite s = new TestSuite( "NormalizationMeTTests" );
        s.addTestSuite( NormalizationMeTTests.class );

        return s;
    }

    public void testNormalization1() {
    ATermFactory factory = ATermUtils.getFactory();
    TBoxImpl tbox = null;
    int numTest,i = 0;
    ATerm t = null;
    String s = null;
    org.mindswap.pellet.utils.Timer timer = new org.mindswap.pellet.utils.Timer("Normalization");
//        if (args.length > 0) {
//        java.io.File file = new java.io.File(args[0]);
        java.io.File file = new java.io.File(base + "/test1.txt");
        StringBuffer buf = new StringBuffer();
        java.io.BufferedReader reader = null;
        String text = null;
        String[] timers = null;
        ArrayList[] testres = null;
//------------------Reading the test file----------------
        try {
        reader = new java.io.BufferedReader(new java.io.FileReader(file));
        numTest = new Integer(reader.readLine());
            timers = new String[numTest];
            testres = new ArrayList[numTest];
        while ((text = reader.readLine()) != null)
        {
            buf.append(text);
            s = buf.toString();
            timer.start();
            t = factory.parse(s);
            tbox = new TBoxImpl(null);
            tbox.addAxioms((ATermList) t);
            try {
                i++;
                tbox.split();
                tbox.absorb();
                tbox.internalize();
                } catch (Exception e) {e.printStackTrace();}
            timer.stop();
            System.out.println("test " + i + " : "+  " : "+  timer.getLast());
            System.out.print("Tg box :"); tbox.Tg.print();
            timers[i-1] = "test " + " : " + i + " : "+  timer.getLast();
             testres[i-1] = new ArrayList();
            if( tbox.getUC() != null ) {
            for(ATermList list = ATermUtils.nnf(tbox.getUC()); !list.isEmpty(); list = list.getNext()) {
                testres[i-1].add(list.getFirst());
                }
            }
            buf.delete(0,buf.capacity());
            }
            } catch (java.io.FileNotFoundException e)
            {e.printStackTrace();} catch (java.io.IOException e) { e.printStackTrace();
            } finally
                { try
                    {  if (reader != null)
                        { reader.close(); }
                    } catch (java.io.IOException e) { e.printStackTrace(); }
                }
//--------------Resulting timers-to file-----------------

            java.io.Writer writer = null;
            try
            {
            java.io.File file2 = new java.io.File(base + "/test1-timers.txt");
            writer = new java.io.BufferedWriter(new java.io.FileWriter(file2));
                for (i = 0;i<timers.length;i++) {
                    writer.write(timers[i]);
                    writer.write(System.getProperty("line.separator"));
                }
            } catch (java.io.FileNotFoundException e)
            { e.printStackTrace();} catch (java.io.IOException e) {e.printStackTrace();
            } finally
            {  try
                 { if (writer != null)
                 { writer.close(); }
            } catch (java.io.IOException e)
            { e.printStackTrace(); }
            }
//--------------Resulting normalized tboxes-to file-----------------

            try
            {
            java.io.File file2 = new java.io.File(base + "/test1-res.txt");
            writer = new java.io.BufferedWriter(new java.io.FileWriter(file2));
                for (i = 0;i<testres.length;i++) {
                    if (testres[i]==null)
                    writer.write("empty");
                    else
                    writer.write(testres[i].toString());
                   // writer.write(testres[i]);
                    writer.write(System.getProperty("line.separator"));
                }
            } catch (java.io.FileNotFoundException e)
            { e.printStackTrace();} catch (java.io.IOException e) {e.printStackTrace();
            } finally
            {  try
                 { if (writer != null)
                 { writer.close(); }
            } catch (java.io.IOException e)
            { e.printStackTrace(); }
            }
    }

    public void testNormalization2() {
    ATermFactory factory = ATermUtils.getFactory();
    TBoxImpl tbox = null;
    int numTest,i = 0;
    ATerm t = null;
    String s = null;
    org.mindswap.pellet.utils.Timer timer = new org.mindswap.pellet.utils.Timer("Normalization");
//        if (args.length > 0) {
//        java.io.File file = new java.io.File(args[0]);
        java.io.File file = new java.io.File(base + "/test2.txt");
        StringBuffer buf = new StringBuffer();
        java.io.BufferedReader reader = null;
        String text = null;
        String[] timers = null;
        ArrayList[] testres = null;
//------------------Reading the test file----------------
        try {
        reader = new java.io.BufferedReader(new java.io.FileReader(file));
        numTest = new Integer(reader.readLine());
            timers = new String[numTest];
            testres = new ArrayList[numTest];
        while ((text = reader.readLine()) != null)
        {
            buf.append(text);
            s = buf.toString();
            timer.start();
            t = factory.parse(s);
            tbox = new TBoxImpl(null);
            tbox.addAxioms((ATermList) t);
            try {
                i++;
                tbox.split();
                tbox.absorb();
                tbox.internalize();
                } catch (Exception e) {e.printStackTrace();}
            timer.stop();
            System.out.println("test " + i + " : "+  " : "+  timer.getLast());
            System.out.print("Tg box :"); tbox.Tg.print();
            timers[i-1] = "test " + " : " + i + " : "+  timer.getLast();
             testres[i-1] = new ArrayList();
            if( tbox.getUC() != null ) {
            for(ATermList list = ATermUtils.nnf(tbox.getUC()); !list.isEmpty(); list = list.getNext()) {
                testres[i-1].add(list.getFirst());
                }
            }
            buf.delete(0,buf.capacity());
            }
            } catch (java.io.FileNotFoundException e)
            {e.printStackTrace();} catch (java.io.IOException e) { e.printStackTrace();
            } finally
                { try
                    {  if (reader != null)
                        { reader.close(); }
                    } catch (java.io.IOException e) { e.printStackTrace(); }
                }
//--------------Resulting timers-to file-----------------

            java.io.Writer writer = null;
            try
            {
            java.io.File file2 = new java.io.File(base + "/test2-timers.txt");
            writer = new java.io.BufferedWriter(new java.io.FileWriter(file2));
                for (i = 0;i<timers.length;i++) {
                    writer.write(timers[i]);
                    writer.write(System.getProperty("line.separator"));
                }
            } catch (java.io.FileNotFoundException e)
            { e.printStackTrace();} catch (java.io.IOException e) {e.printStackTrace();
            } finally
            {  try
                 { if (writer != null)
                 { writer.close(); }
            } catch (java.io.IOException e)
            { e.printStackTrace(); }
            }
//--------------Resulting normalized tboxes-to file-----------------

            try
            {
            java.io.File file2 = new java.io.File(base + "/test2-res.txt");
            writer = new java.io.BufferedWriter(new java.io.FileWriter(file2));
                for (i = 0;i<testres.length;i++) {
                    if (testres[i]==null)
                    writer.write("empty");
                    else
                    writer.write(testres[i].toString());
                   // writer.write(testres[i]);
                    writer.write(System.getProperty("line.separator"));
                }
            } catch (java.io.FileNotFoundException e)
            { e.printStackTrace();} catch (java.io.IOException e) {e.printStackTrace();
            } finally
            {  try
                 { if (writer != null)
                 { writer.close(); }
            } catch (java.io.IOException e)
            { e.printStackTrace(); }
            }
    }

    public void testNormalization3() {
    ATermFactory factory = ATermUtils.getFactory();
    TBoxImpl tbox = null;
    int numTest,i = 0;
    ATerm t = null;
    String s = null;
    org.mindswap.pellet.utils.Timer timer = new org.mindswap.pellet.utils.Timer("Normalization");
//        if (args.length > 0) {
//        java.io.File file = new java.io.File(args[0]);
        java.io.File file = new java.io.File(base + "/test3.txt");
        StringBuffer buf = new StringBuffer();
        java.io.BufferedReader reader = null;
        String text = null;
        String[] timers = null;
        ArrayList[] testres = null;
//------------------Reading the test file----------------
        try {
        reader = new java.io.BufferedReader(new java.io.FileReader(file));
        numTest = new Integer(reader.readLine());
            timers = new String[numTest];
            testres = new ArrayList[numTest];
        while ((text = reader.readLine()) != null)
        {
            buf.append(text);
            s = buf.toString();
            timer.start();
            t = factory.parse(s);
            tbox = new TBoxImpl(null);
            tbox.addAxioms((ATermList) t);
            try {
                i++;
                tbox.split();
                tbox.absorb();
                tbox.internalize();
                } catch (Exception e) {e.printStackTrace();}
            timer.stop();
            System.out.println("test " + i + " : "+  " : "+  timer.getLast());
            System.out.print("Tg box :"); tbox.Tg.print();
            timers[i-1] = "test " + " : " + i + " : "+  timer.getLast();
             testres[i-1] = new ArrayList();
            if( tbox.getUC() != null ) {
            for(ATermList list = ATermUtils.nnf(tbox.getUC()); !list.isEmpty(); list = list.getNext()) {
                testres[i-1].add(list.getFirst());
                }
            }
            buf.delete(0,buf.capacity());
            }
            } catch (java.io.FileNotFoundException e)
            {e.printStackTrace();} catch (java.io.IOException e) { e.printStackTrace();
            } finally
                { try
                    {  if (reader != null)
                        { reader.close(); }
                    } catch (java.io.IOException e) { e.printStackTrace(); }
                }
//--------------Resulting timers-to file-----------------

            java.io.Writer writer = null;
            try
            {
            java.io.File file2 = new java.io.File(base + "/test3-timers.txt");
            writer = new java.io.BufferedWriter(new java.io.FileWriter(file2));
                for (i = 0;i<timers.length;i++) {
                    writer.write(timers[i]);
                    writer.write(System.getProperty("line.separator"));
                }
            } catch (java.io.FileNotFoundException e)
            { e.printStackTrace();} catch (java.io.IOException e) {e.printStackTrace();
            } finally
            {  try
                 { if (writer != null)
                 { writer.close(); }
            } catch (java.io.IOException e)
            { e.printStackTrace(); }
            }
//--------------Resulting normalized tboxes-to file-----------------

            try
            {
            java.io.File file2 = new java.io.File(base + "/test3-res.txt");
            writer = new java.io.BufferedWriter(new java.io.FileWriter(file2));
                for (i = 0;i<testres.length;i++) {
                    if (testres[i]==null)
                    writer.write("empty");
                    else
                    writer.write(testres[i].toString());
                   // writer.write(testres[i]);
                    writer.write(System.getProperty("line.separator"));
                }
            } catch (java.io.FileNotFoundException e)
            { e.printStackTrace();} catch (java.io.IOException e) {e.printStackTrace();
            } finally
            {  try
                 { if (writer != null)
                 { writer.close(); }
            } catch (java.io.IOException e)
            { e.printStackTrace(); }
            }
    }

    public void testNormalization4() {
    ATermFactory factory = ATermUtils.getFactory();
    TBoxImpl tbox = null;
    int numTest,i = 0;
    ATerm t = null;
    String s = null;
    org.mindswap.pellet.utils.Timer timer = new org.mindswap.pellet.utils.Timer("Normalization");
//        if (args.length > 0) {
//        java.io.File file = new java.io.File(args[0]);
        java.io.File file = new java.io.File(base + "/test4.txt");
        StringBuffer buf = new StringBuffer();
        java.io.BufferedReader reader = null;
        String text = null;
        String[] timers = null;
        ArrayList[] testres = null;
//------------------Reading the test file----------------
        try {
        reader = new java.io.BufferedReader(new java.io.FileReader(file));
        numTest = new Integer(reader.readLine());
            timers = new String[numTest];
            testres = new ArrayList[numTest];
        while ((text = reader.readLine()) != null)
        {
            buf.append(text);
            s = buf.toString();
            timer.start();
            t = factory.parse(s);
            tbox = new TBoxImpl(null);
            tbox.addAxioms((ATermList) t);
            try {
                i++;
                tbox.split();
                tbox.absorb();
                tbox.internalize();
                } catch (Exception e) {e.printStackTrace();}
            timer.stop();
            System.out.println("test " + i + " : "+  " : "+  timer.getLast());
            System.out.print("Tg box :"); tbox.Tg.print();
            timers[i-1] = "test " + " : " + i + " : "+  timer.getLast();
             testres[i-1] = new ArrayList();
            if( tbox.getUC() != null ) {
            for(ATermList list = ATermUtils.nnf(tbox.getUC()); !list.isEmpty(); list = list.getNext()) {
                testres[i-1].add(list.getFirst());
                }
            }
            buf.delete(0,buf.capacity());
            }
            } catch (java.io.FileNotFoundException e)
            {e.printStackTrace();} catch (java.io.IOException e) { e.printStackTrace();
            } finally
                { try
                    {  if (reader != null)
                        { reader.close(); }
                    } catch (java.io.IOException e) { e.printStackTrace(); }
                }
//--------------Resulting timers-to file-----------------

            java.io.Writer writer = null;
            try
            {
            java.io.File file2 = new java.io.File(base + "/test4-timers.txt");
            writer = new java.io.BufferedWriter(new java.io.FileWriter(file2));
                for (i = 0;i<timers.length;i++) {
                    writer.write(timers[i]);
                    writer.write(System.getProperty("line.separator"));
                }
            } catch (java.io.FileNotFoundException e)
            { e.printStackTrace();} catch (java.io.IOException e) {e.printStackTrace();
            } finally
            {  try
                 { if (writer != null)
                 { writer.close(); }
            } catch (java.io.IOException e)
            { e.printStackTrace(); }
            }
//--------------Resulting normalized tboxes-to file-----------------

            try
            {
            java.io.File file2 = new java.io.File(base + "/test4-res.txt");
            writer = new java.io.BufferedWriter(new java.io.FileWriter(file2));
                for (i = 0;i<testres.length;i++) {
                    if (testres[i]==null)
                    writer.write("empty");
                    else
                    writer.write(testres[i].toString());
                   // writer.write(testres[i]);
                    writer.write(System.getProperty("line.separator"));
                }
            } catch (java.io.FileNotFoundException e)
            { e.printStackTrace();} catch (java.io.IOException e) {e.printStackTrace();
            } finally
            {  try
                 { if (writer != null)
                 { writer.close(); }
            } catch (java.io.IOException e)
            { e.printStackTrace(); }
            }
    }

    public void testNormalization5() {
    ATermFactory factory = ATermUtils.getFactory();
    TBoxImpl tbox = null;
    int numTest,i = 0;
    ATerm t = null;
    String s = null;
    org.mindswap.pellet.utils.Timer timer = new org.mindswap.pellet.utils.Timer("Normalization");
//        if (args.length > 0) {
//        java.io.File file = new java.io.File(args[0]);
        java.io.File file = new java.io.File(base + "/test5.txt");
        StringBuffer buf = new StringBuffer();
        java.io.BufferedReader reader = null;
        String text = null;
        String[] timers = null;
        ArrayList[] testres = null;
//------------------Reading the test file----------------
        try {
        reader = new java.io.BufferedReader(new java.io.FileReader(file));
        numTest = new Integer(reader.readLine());
            timers = new String[numTest];
            testres = new ArrayList[numTest];
        while ((text = reader.readLine()) != null)
        {
            buf.append(text);
            s = buf.toString();
            timer.start();
            t = factory.parse(s);
            tbox = new TBoxImpl(null);
            tbox.addAxioms((ATermList) t);
            try {
                i++;
                tbox.split();
                tbox.absorb();
                tbox.internalize();
                } catch (Exception e) {e.printStackTrace();}
            timer.stop();
            System.out.println("test " + i + " : "+  " : "+  timer.getLast());
            System.out.print("Tg box :"); tbox.Tg.print();
            timers[i-1] = "test " + " : " + i + " : "+  timer.getLast();
             testres[i-1] = new ArrayList();
            if( tbox.getUC() != null ) {
            for(ATermList list = ATermUtils.nnf(tbox.getUC()); !list.isEmpty(); list = list.getNext()) {
                testres[i-1].add(list.getFirst());
                }
            }
            buf.delete(0,buf.capacity());
            }
            } catch (java.io.FileNotFoundException e)
            {e.printStackTrace();} catch (java.io.IOException e) { e.printStackTrace();
            } finally
                { try
                    {  if (reader != null)
                        { reader.close(); }
                    } catch (java.io.IOException e) { e.printStackTrace(); }
                }
//--------------Resulting timers-to file-----------------

            java.io.Writer writer = null;
            try
            {
            java.io.File file2 = new java.io.File(base + "/test5-timers.txt");
            writer = new java.io.BufferedWriter(new java.io.FileWriter(file2));
                for (i = 0;i<timers.length;i++) {
                    writer.write(timers[i]);
                    writer.write(System.getProperty("line.separator"));
                }
            } catch (java.io.FileNotFoundException e)
            { e.printStackTrace();} catch (java.io.IOException e) {e.printStackTrace();
            } finally
            {  try
                 { if (writer != null)
                 { writer.close(); }
            } catch (java.io.IOException e)
            { e.printStackTrace(); }
            }
//--------------Resulting normalized tboxes-to file-----------------

            try
            {
            java.io.File file2 = new java.io.File(base + "/test5-res.txt");
            writer = new java.io.BufferedWriter(new java.io.FileWriter(file2));
                for (i = 0;i<testres.length;i++) {
                    if (testres[i]==null)
                    writer.write("empty");
                    else
                    writer.write(testres[i].toString());
                   // writer.write(testres[i]);
                    writer.write(System.getProperty("line.separator"));
                }
            } catch (java.io.FileNotFoundException e)
            { e.printStackTrace();} catch (java.io.IOException e) {e.printStackTrace();
            } finally
            {  try
                 { if (writer != null)
                 { writer.close(); }
            } catch (java.io.IOException e)
            { e.printStackTrace(); }
            }
    }



}
