package org.mindswap.pelletmet;

/**
 * User: NataKeberle
 * Date: 24/07/2009
 * Time: 10:57:47
 */

import junit.framework.*;
import org.mindswap.pellet.utils.*;

import java.io.*;
import java.util.*;

public class OWLMeTTestSuite extends TestSuite {
    public static String base = "test_data/owl-met-test/";

    private OWLMeTTest test = new OWLMeTTest();

    class OWLMeTTestCase extends TestCase {
        String name;
        boolean tbox;

        OWLMeTTestCase( String name, boolean tbox ) {
            super( "MeT-" + name );
            this.name = name;
            this.tbox = tbox;
        }

        public void runTest() throws Exception {
            boolean pass = false;

                pass = test.doTBoxTest( "file:"+name );

            assertTrue( pass );
        }
    }

    public OWLMeTTestSuite() {
        super( "MeTTests" );

		File dir = new File( base + "owlmet" );
		File[] files = dir.listFiles( new FilenameFilter() {
			public boolean accept(File dir, String name) {
				return dir != null && name.endsWith(".txt");
			}
		});

		Arrays.sort(files, AlphaNumericComparator.CASE_INSENSITIVE);
        String[] names = new String[files.length];

		for (int i = 0; i < files.length; i++) {
            names[i] = files[i].getAbsolutePath();
            names[i] = replaceFileSep(names[i]);
			addTest( new OWLMeTTestCase( names[i], true ) );
		}
    }

    public static TestSuite suite() {
        return new OWLMeTTestSuite();
    }

    public String replaceFileSep (String s) {
        String s1, s2, sfin = "";
        if (s.indexOf("\\") != -1) {
        s1 = s.substring(0, s.indexOf("\\"));

        int pos = s.indexOf("\\");
        s2 = s.substring(pos+1);
        s2 = replaceFileSep(s2);
        sfin = (s1.concat("/")).concat(s2);
        }
        else {
            sfin = s;
        }
        return sfin;
    }
}
