package org.mindswap.pelletmet;

/**
 * User: NataKeberle
 * Date: 23/07/2009
 * Time: 20:32:31
 */


public class PelletMeTTestCase extends junit.framework.TestCase {
    static aterm.ATermAppl TOP = org.mindswap.pellet.utils.ATermUtils.TOP;
    static aterm.ATermAppl BOTTOM = org.mindswap.pellet.utils.ATermUtils.BOTTOM;

    public static aterm.ATermAppl allfut(aterm.ATermAppl c) {
        return org.mindswap.pellet.utils.ATermUtils.makeAllfuture(c);
    }

    public static aterm.ATermAppl allpast(aterm.ATermAppl c) {
        return org.mindswap.pellet.utils.ATermUtils.makeAllpast(c);
    }

    public static aterm.ATermAppl somefut(aterm.ATermAppl c) {
        return org.mindswap.pellet.utils.ATermUtils.makeSomefuture(c);
    }

    public static aterm.ATermAppl somepast(aterm.ATermAppl c) {
        return org.mindswap.pellet.utils.ATermUtils.makeSomepast(c);
    }

    public static aterm.ATermAppl fut(aterm.ATermAppl c1, int i) {
        return org.mindswap.pellet.utils.ATermUtils.makeFuture(c1, i);
    }

    public static aterm.ATermAppl past(aterm.ATermAppl c1, int i) {
        return org.mindswap.pellet.utils.ATermUtils.makePast(c1, i);
    }

    public static aterm.ATermAppl at(aterm.ATermAppl c1, aterm.ATermAppl c2) {
        return org.mindswap.pellet.utils.ATermUtils.makeAt(c1, c2);
    }

    public static aterm.ATermAppl term(String s) {
        return org.mindswap.pellet.utils.ATermUtils.makeTermAppl(s);
    }

    public static aterm.ATermAppl not(aterm.ATermAppl c) {
		return org.mindswap.pellet.utils.ATermUtils.makeNot(c);
	}

	public static aterm.ATermAppl all(aterm.ATermAppl r, aterm.ATermAppl c) {
		return org.mindswap.pellet.utils.ATermUtils.makeAllValues(r, c);
	}

	public static aterm.ATermAppl some(aterm.ATermAppl r, aterm.ATermAppl c) {
		return org.mindswap.pellet.utils.ATermUtils.makeSomeValues(r, c);
	}

	public static aterm.ATermAppl min(aterm.ATermAppl r, int n) {
		return org.mindswap.pellet.utils.ATermUtils.makeMin(r, n);
	}

	public static aterm.ATermAppl max(aterm.ATermAppl r, int n) {
		return org.mindswap.pellet.utils.ATermUtils.makeMax(r, n);
	}

	public static aterm.ATermAppl inv(aterm.ATermAppl r) {
		return org.mindswap.pellet.utils.ATermUtils.makeInv(r);
	}

	public static aterm.ATermAppl literal(String value) {
		return org.mindswap.pellet.utils.ATermUtils.makePlainLiteral(value);
	}

	public static aterm.ATermAppl plainLiteral(String value, String lang) {
		return org.mindswap.pellet.utils.ATermUtils.makePlainLiteral(value, lang);
	}

	public static aterm.ATermAppl typedLiteral(String value, String dt) {
		return org.mindswap.pellet.utils.ATermUtils.makeTypedLiteral(value, dt);
	}

	public static aterm.ATermAppl value(aterm.ATermAppl r) {
		return org.mindswap.pellet.utils.ATermUtils.makeValue(r);
	}

	public static aterm.ATermAppl and(aterm.ATermAppl c1, aterm.ATermAppl c2) {
		return org.mindswap.pellet.utils.ATermUtils.makeAnd(c1, c2);
	}

	public static aterm.ATermAppl and(aterm.ATermAppl[] c) {
		return org.mindswap.pellet.utils.ATermUtils.makeAnd(org.mindswap.pellet.utils.ATermUtils.makeList(c));
	}

	public static aterm.ATermAppl or(aterm.ATermAppl c1, aterm.ATermAppl c2) {
		return org.mindswap.pellet.utils.ATermUtils.makeOr(c1, c2);
	}

	public static aterm.ATermAppl or(aterm.ATermAppl[] c) {
		return org.mindswap.pellet.utils.ATermUtils.makeOr(org.mindswap.pellet.utils.ATermUtils.makeList(c));
	}



    protected static boolean isAnonValue( Object n ) {
        return ((n instanceof com.hp.hpl.jena.rdf.model.Resource) && ((com.hp.hpl.jena.rdf.model.Resource) n).isAnon()) ||
               ((n instanceof com.hp.hpl.jena.rdf.model.Statement) && ((com.hp.hpl.jena.rdf.model.Statement) n).getSubject().isAnon()) ||
               ((n instanceof com.hp.hpl.jena.rdf.model.Statement) && isAnonValue( ((com.hp.hpl.jena.rdf.model.Statement) n).getObject() ));
    }

    public static void assertCollectionValues(junit.framework.TestCase testCase, java.util.Collection coll, Object[] vals) {
        boolean[] found = new boolean[vals.length];

        for (int i = 0; i < vals.length; i++) found[i] = false;

        java.util.Collection flattened = org.mindswap.pellet.utils.SetUtils.union( coll );
        java.util.Iterator it = flattened.iterator();
        while (it.hasNext()) {
            Object n = it.next();
            boolean gotit = false;

            for (int i = 0; i < vals.length; i++) {
                if (n.equals(vals[i])) {
                    gotit = true;
                    found[i] = true;
                }
            }
            junit.framework.TestCase.assertTrue( testCase.getName() + " found unexpected value: " + n, gotit);
        }

        // check that no expected values were unfound
        for (int i = 0; i < vals.length; i++) {
            junit.framework.TestCase.assertTrue(testCase.getName() + " failed to find expected value: " + vals[i], found[i]);
        }
    }

    public static void assertIteratorContains(junit.framework.TestCase testCase, java.util.Iterator it, Object val) {
        boolean found = false;
        while( it.hasNext() && !found ) {
            Object obj = it.next();
            found = obj.equals( val );
        }

        junit.framework.TestCase.assertTrue(testCase.getName() + " failed to find expected iterator value: " + val, found );
    }

    public static void assertIteratorValues(junit.framework.TestCase testCase, java.util.Iterator it, Object[] vals) {
        boolean[] found = new boolean[vals.length];

        for (int i = 0; i < vals.length; i++) found[i] = false;

        while (it.hasNext()) {
            Object n = it.next();
            boolean gotit = false;

            for (int i = 0; i < vals.length; i++) {
                if (n.equals(vals[i])) {
                    gotit = true;
                    found[i] = true;
                }
            }
            junit.framework.TestCase.assertTrue( testCase.getName() + " found unexpected iterator value: " + n, gotit);
        }

        // check that no expected values were unfound
        for (int i = 0; i < vals.length; i++) {
            junit.framework.TestCase.assertTrue(testCase.getName() + " failed to find expected iterator value: " + vals[i], found[i]);
        }
    }


	public static void testResultSet( com.hp.hpl.jena.query.ResultSet results, java.util.List ans ) {
	    java.util.List answers = new java.util.ArrayList( ans );
        while( results.hasNext() ) {
            com.hp.hpl.jena.query.QuerySolution sol = results.nextSolution();
            assertNotNull( "QuerySolution", sol );

            java.util.Map answer = new java.util.HashMap();
            for ( java.util.Iterator iter = results.getResultVars().iterator() ; iter.hasNext() ; ) {
                String var = (String)iter.next() ;
                Object val = sol.get( var ) ;
                assertNotNull( "Variable: " + var, val ) ;

                answer.put( var, val );
            }

            assertTrue( "Unexpected binding found: " + answer, answers.remove( answer ) );
        }

        assertTrue( "Binding not found: " + answers, answers.isEmpty() );
    }

	public static java.util.Map createBinding( Object[] keys, Object[] values ) {
        assertTrue( keys.length == values.length );

        java.util.Map answer = new java.util.HashMap();
        for( int i = 0; i < keys.length; i++ )
            answer.put( keys[i], values[i] );

        return answer;
    }

	public static java.util.List createBindings( Object[] keys, Object[][] values ) {
        java.util.List answers = new java.util.ArrayList();
        for( int i = 0; i < values.length; i++ ) {
	        java.util.Map answer = new java.util.HashMap();
	        for( int j = 0; j < keys.length; j++ )
	            answer.put( keys[j], values[i][j] );
	        answers.add( answer );
    	}

        return answers;
    }

	public static void printAll(java.util.Iterator i) {
	    while(i.hasNext()) {
	        System.out.println(i.next());
	    }
	}

	public static void printAll(java.util.Iterator i, String head) {
	    System.out.print( head + ": ");
	    if( i.hasNext()) {
	        System.out.println();
		    while(i.hasNext()) {
		        System.out.println(i.next());
		    }
	    }
	    else
	        System.out.println( "<EMPTY>" );
	}


	public static boolean[] testSubClass(org.mindswap.pellet.KnowledgeBase kb, String c1, String c2) {
	    return testSubClass(kb, term(c1), term(c2));
	}

	public static boolean[] testSubClass(org.mindswap.pellet.KnowledgeBase kb, aterm.ATermAppl c1, aterm.ATermAppl c2) {
	    boolean result[] = new boolean [2];

	    result[0] = kb.isSubClassOf(c1, c2);
		kb.isSatisfiable(c1);
		kb.isSatisfiable(not(c1));
		kb.isSatisfiable(c2);
		kb.isSatisfiable(not(c2));

		long satCount = kb.getABox().satisfiabilityCount;
		result[1] = kb.isSubClassOf(c1, c2);
		boolean cached = (satCount == kb.getABox().satisfiabilityCount);

		System.out.println("Subsumption : " + result[0]);
		System.out.println("Cached " + (cached?"(yes)":"(no) ")+ ": " + result[1]);

		return result;
	}

	public static boolean[] testType(org.mindswap.pellet.KnowledgeBase kb, String c1, String c2) {
	    return testType(kb, term(c1), term(c2));
	}

	public static boolean[] testType(org.mindswap.pellet.KnowledgeBase kb, aterm.ATermAppl ind, aterm.ATermAppl c) {
	    boolean result[] = new boolean [2];

	    result[0] = kb.isType( ind, c );
		kb.isSatisfiable(c);
		kb.isSatisfiable(not(c));

		long satCount = kb.getABox().satisfiabilityCount;
		result[1] = kb.isType( ind, c );
		boolean cached = (satCount == kb.getABox().satisfiabilityCount);

		System.out.println("Type      : " + result[0]);
		System.out.println("Cached " + (cached?"(yes)":"(no) ")+ ": " + result[1]);

		return result;
	}
}